3 # Fake Root Solaris/SVR4/SVR5 Build System - Prototype
5 # The following code has been provide under Public Domain License. I really
6 # don't care what you use it for. Just as long as you don't complain to me
7 # nor my employer if you break it. - Ben Lindstrom (mouring@eviladmin.org)
11 # Options for building the package
12 # You can create a openssh-config.local with your customized options
14 REMOVE_FAKE_ROOT_WHEN_DONE
=yes
16 # uncommenting TEST_DIR and using
17 # configure --prefix=/var/tmp --with-privsep-path=/var/tmp/empty
19 # PKGNAME=tOpenSSH should allow testing a package without interfering
20 # with a real OpenSSH package on a system. This is not needed on systems
21 # that support the -R option to pkgadd.
22 #TEST_DIR=/var/tmp # leave commented out for production build
24 # revisions within the same version (REV=a)
26 SYSVINIT_NAME
=opensshd
29 SSHDUID
=67 # Default privsep uid
30 SSHDGID
=67 # Default privsep gid
31 # uncomment these next three as needed
34 #USR_LOCAL_IS_SYMLINK=yes
35 # System V init run levels
38 # We will source these if they exist
39 POST_MAKE_INSTALL_FIXES
=.
/pkg-post-make-install-fixes.sh
40 POST_PROTOTYPE_EDITS
=.
/pkg-post-prototype-edit.sh
41 # We'll be one level deeper looking for these
42 PKG_PREINSTALL_LOCAL
=..
/pkg-preinstall.
local
43 PKG_POSTINSTALL_LOCAL
=..
/pkg-postinstall.
local
44 PKG_PREREMOVE_LOCAL
=..
/pkg-preremove.
local
45 PKG_POSTREMOVE_LOCAL
=..
/pkg-postremove.
local
46 PKG_REQUEST_LOCAL
=..
/pkg-request.
local
47 # end of sourced files
49 OPENSSHD
=opensshd.init
50 OPENSSH_MANIFEST
=openssh.xml
51 OPENSSH_FMRI
=svc
:/site
/openssh
:default
53 PATH_GROUPADD_PROG
=@PATH_GROUPADD_PROG@
54 PATH_USERADD_PROG
=@PATH_USERADD_PROG@
55 PATH_PASSWD_PROG
=@PATH_PASSWD_PROG@
57 # list of system directories we do NOT want to change owner/group/perms
58 # when installing our package
69 /lib/svc/method/site \
94 /var/svc/manifest/site \
98 # We may need to build as root so we make sure PATH is set up
99 # only set the path if it's not set already
101 echo $PATH |
grep ":/opt/bin" > /dev
/null
2>&1
102 [ $?
-ne 0 ] && PATH
=$PATH:/opt
/bin
104 [ -d /usr
/local
/bin
] && {
105 echo $PATH |
grep ":/usr/local/bin" > /dev
/null
2>&1
106 [ $?
-ne 0 ] && PATH
=$PATH:/usr
/local
/bin
108 [ -d /usr
/ccs
/bin
] && {
109 echo $PATH |
grep ":/usr/ccs/bin" > /dev
/null
2>&1
110 [ $?
-ne 0 ] && PATH
=$PATH:/usr
/ccs
/bin
116 echo "Please run this script from your build directory"
120 # we will look for openssh-config.local to override the above options
121 [ -s .
/openssh-config.
local ] && . .
/openssh-config.
local
126 ## Fill in some details, like prefix and sysconfdir
127 for confvar
in prefix exec_prefix bindir sbindir libexecdir datadir mandir sysconfdir piddir srcdir
129 eval $confvar=`grep "^$confvar=" Makefile | cut -d = -f 2`
132 ## Are we using Solaris' SMF?
134 if egrep "^#define USE_SOLARIS_PROCESS_CONTRACTS" config.h
> /dev
/null
2>&1
139 ## Collect value of privsep user
140 for confvar
in SSH_PRIVSEP_USER
142 eval $confvar=`awk '/#define[ \t]'$confvar'/{print $3}' config.h`
145 ## Set privsep defaults if not defined
146 if [ -z "$SSH_PRIVSEP_USER" ]
148 SSH_PRIVSEP_USER
=sshd
151 ## Extract common info requires for the 'info' part of the package.
152 VERSION
=`./ssh -V 2>&1 | sed -e 's/,.*//'`
157 SCRIPT_SHELL
=/sbin
/sh
161 SunOS
) UNAME_S
=Solaris
165 DEF_MSG
="(default: n)"
167 SCO_SV
) case ${UNAME_R} in
168 3.2) UNAME_S
=OpenServer5
169 OS_VER
=`uname -X | grep Release | sed -e 's/^Rel.*3.2v//'`
171 5) UNAME_S
=OpenServer6
176 DEF_MSG
="(default: n)"
180 case `basename $0` in
182 ## Start by faking root install
183 echo "Faking root install..."
184 [ -d $FAKE_ROOT ] && rm -fr $FAKE_ROOT
186 ${MAKE} install-nokeys DESTDIR
=$FAKE_ROOT
189 echo "Fake root install failed, stopping."
193 ## Setup our run level stuff while we are at it.
196 # For Solaris' SMF, /lib/svc/method/site is the preferred place
197 # for start/stop scripts that aren't supplied with the OS, and
198 # similarly /var/svc/manifest/site for manifests.
199 mkdir
-p $FAKE_ROOT${TEST_DIR}/lib
/svc
/method
/site
200 mkdir
-p $FAKE_ROOT${TEST_DIR}/var
/svc
/manifest
/site
202 cp ${OPENSSHD} $FAKE_ROOT${TEST_DIR}/lib/svc/method/site/${SYSVINIT_NAME}
203 chmod 744 $FAKE_ROOT${TEST_DIR}/lib
/svc
/method
/site
/${SYSVINIT_NAME}
205 cp ${OPENSSH_MANIFEST} $FAKE_ROOT${TEST_DIR}/var
/svc
/manifest
/site
206 chmod 644 $FAKE_ROOT${TEST_DIR}/var
/svc
/manifest
/site
/${OPENSSH_MANIFEST}
208 mkdir
-p $FAKE_ROOT${TEST_DIR}/etc
/init.d
210 cp ${OPENSSHD} $FAKE_ROOT${TEST_DIR}/etc/init.d/${SYSVINIT_NAME}
211 chmod 744 $FAKE_ROOT${TEST_DIR}/etc
/init.d
/${SYSVINIT_NAME}
214 [ "${PERMIT_ROOT_LOGIN}" = no
] && \
215 perl
-p -i -e "s/#PermitRootLogin yes/PermitRootLogin no/" \
216 $FAKE_ROOT/${sysconfdir}/sshd_config
217 [ "${X11_FORWARDING}" = yes ] && \
218 perl
-p -i -e "s/#X11Forwarding no/X11Forwarding yes/" \
219 $FAKE_ROOT/${sysconfdir}/sshd_config
221 perl
-p -i -e "s/#PrintMotd yes/PrintMotd no/" \
222 $FAKE_ROOT/${sysconfdir}/sshd_config
224 # We don't want to overwrite config files on multiple installs
225 mv $FAKE_ROOT/${sysconfdir}/ssh_config
$FAKE_ROOT/${sysconfdir}/ssh_config.default
226 mv $FAKE_ROOT/${sysconfdir}/sshd_config
$FAKE_ROOT/${sysconfdir}/sshd_config.default
227 [ -f $FAKE_ROOT/${sysconfdir}/ssh_prng_cmds
] && \
228 mv $FAKE_ROOT/${sysconfdir}/ssh_prng_cmds
$FAKE_ROOT/${sysconfdir}/ssh_prng_cmds.default
231 [ -s "${POST_MAKE_INSTALL_FIXES}" ] && .
${POST_MAKE_INSTALL_FIXES}
235 ## Ok, this is outright wrong, but it will work. I'm tired of pkgmk
238 PROTO_ARGS
="$PROTO_ARGS $i=/$i";
242 echo "Building pkginfo file..."
243 cat > pkginfo
<< _EOF
245 NAME="OpenSSH Portable for ${UNAME_S}"
246 DESC="Secure Shell remote access utility; replaces telnet and rlogin/rsh."
247 VENDOR="OpenSSH Portable Team - http://www.openssh.com/portable.html"
250 CATEGORY="Security,application"
253 PSTAMP="${UNAME_S} ${OS_VER} ${ARCH} `date '+%d%b%Y %H:%M'`"
256 ## Build empty depend file that may get updated by $POST_PROTOTYPE_EDITS
257 echo "Building depend file..."
261 echo "Building space file..."
264 # XXX Is this necessary? If not, remove space line from mk-proto.awk.
268 # extra space required by start/stop links added by installf
270 $TEST_DIR/etc/rc0.d/${SYSVINITSTOPT}${SYSVINIT_NAME} 0 1
271 $TEST_DIR/etc/rc2.d/${SYSVINITSTART}${SYSVINIT_NAME} 0 1
273 [ "$RC1_D" = no
] || \
274 echo "$TEST_DIR/etc/rc1.d/${SYSVINITSTOPT}${SYSVINIT_NAME} 0 1" >> space
275 [ "$RCS_D" = yes ] && \
276 echo "$TEST_DIR/etc/rcS.d/${SYSVINITSTOPT}${SYSVINIT_NAME} 0 1" >> space
279 ## Build preinstall file
280 echo "Building preinstall file..."
281 cat > preinstall
<< _EOF
286 # local preinstall changes here
287 [ -s "${PKG_PREINSTALL_LOCAL}" ] && .
${PKG_PREINSTALL_LOCAL}
289 cat >> preinstall
<< _EOF
291 if [ "\${PRE_INS_STOP}" = "yes" ]
295 svcadm disable $OPENSSH_FMRI
297 ${TEST_DIR}/etc/init.d/${SYSVINIT_NAME} stop
304 ## Build postinstall file
305 echo "Building postinstall file..."
306 cat > postinstall
<< _EOF
309 [ -f \${PKG_INSTALL_ROOT}${sysconfdir}/ssh_config ] || \\
310 cp -p \${PKG_INSTALL_ROOT}${sysconfdir}/ssh_config.default \\
311 \${PKG_INSTALL_ROOT}${sysconfdir}/ssh_config
312 [ -f \${PKG_INSTALL_ROOT}${sysconfdir}/sshd_config ] || \\
313 cp -p \${PKG_INSTALL_ROOT}${sysconfdir}/sshd_config.default \\
314 \${PKG_INSTALL_ROOT}${sysconfdir}/sshd_config
315 [ -f \${PKG_INSTALL_ROOT}${sysconfdir}/ssh_prng_cmds.default ] && {
316 [ -f \${PKG_INSTALL_ROOT}${sysconfdir}/ssh_prng_cmds ] || \\
317 cp -p \${PKG_INSTALL_ROOT}${sysconfdir}/ssh_prng_cmds.default \\
318 \${PKG_INSTALL_ROOT}${sysconfdir}/ssh_prng_cmds
321 # make rc?.d dirs only if we are doing a test install
322 [ -n "${TEST_DIR}" ] && [ $DO_SMF -ne 1 ] && {
323 [ "$RCS_D" = yes ] && mkdir -p ${TEST_DIR}/etc/rcS.d
324 mkdir -p ${TEST_DIR}/etc/rc0.d
325 [ "$RC1_D" = no ] || mkdir -p ${TEST_DIR}/etc/rc1.d
326 mkdir -p ${TEST_DIR}/etc/rc2.d
331 # Delete the existing service, if it exists, then import the
333 if svcs $OPENSSH_FMRI > /dev/null 2>&1
335 svccfg delete -f $OPENSSH_FMRI
337 # NOTE, if manifest enables sshd by default, this will actually
338 # start the daemon, which may not be what the user wants.
339 svccfg import ${TEST_DIR}/var/svc/manifest/site/$OPENSSH_MANIFEST
341 if [ "\${USE_SYM_LINKS}" = yes ]
343 [ "$RCS_D" = yes ] && \
344 installf ${PKGNAME} \${PKG_INSTALL_ROOT}$TEST_DIR/etc/rcS.d/${SYSVINITSTOPT}${SYSVINIT_NAME}=../init.d/${SYSVINIT_NAME} s
345 installf ${PKGNAME} \${PKG_INSTALL_ROOT}$TEST_DIR/etc/rc0.d/${SYSVINITSTOPT}${SYSVINIT_NAME}=../init.d/${SYSVINIT_NAME} s
346 [ "$RC1_D" = no ] || \
347 installf ${PKGNAME} \${PKG_INSTALL_ROOT}$TEST_DIR/etc/rc1.d/${SYSVINITSTOPT}${SYSVINIT_NAME}=../init.d/${SYSVINIT_NAME} s
348 installf ${PKGNAME} \${PKG_INSTALL_ROOT}$TEST_DIR/etc/rc2.d/${SYSVINITSTART}${SYSVINIT_NAME}=../init.d/${SYSVINIT_NAME} s
350 [ "$RCS_D" = yes ] && \
351 installf ${PKGNAME} \${PKG_INSTALL_ROOT}$TEST_DIR/etc/rcS.d/${SYSVINITSTOPT}${SYSVINIT_NAME}=\${PKG_INSTALL_ROOT}$TEST_DIR/etc/init.d/${SYSVINIT_NAME} l
352 installf ${PKGNAME} \${PKG_INSTALL_ROOT}$TEST_DIR/etc/rc0.d/${SYSVINITSTOPT}${SYSVINIT_NAME}=\${PKG_INSTALL_ROOT}$TEST_DIR/etc/init.d/${SYSVINIT_NAME} l
353 [ "$RC1_D" = no ] || \
354 installf ${PKGNAME} \${PKG_INSTALL_ROOT}$TEST_DIR/etc/rc1.d/${SYSVINITSTOPT}${SYSVINIT_NAME}=\${PKG_INSTALL_ROOT}$TEST_DIR/etc/init.d/${SYSVINIT_NAME} l
355 installf ${PKGNAME} \${PKG_INSTALL_ROOT}$TEST_DIR/etc/rc2.d/${SYSVINITSTART}${SYSVINIT_NAME}=\${PKG_INSTALL_ROOT}$TEST_DIR/etc/init.d/${SYSVINIT_NAME} l
359 # If piddir doesn't exist we add it. (Ie. --with-pid-dir=/var/opt/ssh)
360 [ -d $piddir ] || installf ${PKGNAME} \${PKG_INSTALL_ROOT}$TEST_DIR$piddir d 0755 root sys
364 # local postinstall changes here
365 [ -s "${PKG_POSTINSTALL_LOCAL}" ] && .
${PKG_POSTINSTALL_LOCAL}
367 cat >> postinstall
<< _EOF
368 installf -f ${PKGNAME}
370 # Use chroot to handle PKG_INSTALL_ROOT
371 if [ ! -z "\${PKG_INSTALL_ROOT}" ]
373 chroot="chroot \${PKG_INSTALL_ROOT}"
375 # If this is a test build, we will skip the groupadd/useradd/passwd commands
376 if [ ! -z "${TEST_DIR}" ]
381 echo "PrivilegeSeparation user always required."
382 if cut -f1 -d: \${PKG_INSTALL_ROOT}/etc/passwd | egrep '^'$SSH_PRIVSEP_USER'\$' >/dev/null
384 echo "PrivSep user $SSH_PRIVSEP_USER already exists."
385 SSH_PRIVSEP_GROUP=\`grep "^$SSH_PRIVSEP_USER:" \${PKG_INSTALL_ROOT}/etc/passwd | awk -F: '{print \$4}'\`
386 SSH_PRIVSEP_GROUP=\`grep ":\$SSH_PRIVSEP_GROUP:" \${PKG_INSTALL_ROOT}/etc/group | awk -F: '{print \$1}'\`
390 [ -z "\$SSH_PRIVSEP_GROUP" ] && SSH_PRIVSEP_GROUP=$SSH_PRIVSEP_USER
393 if cut -f1 -d: \${PKG_INSTALL_ROOT}/etc/group | egrep '^'\$SSH_PRIVSEP_GROUP'\$' >/dev/null
395 echo "PrivSep group \$SSH_PRIVSEP_GROUP already exists."
400 # create group if required
401 [ "\$DO_GROUP" = yes ] && {
402 # Use gid of 67 if possible
403 if cut -f3 -d: \${PKG_INSTALL_ROOT}/etc/group | egrep '^'$SSHDGID'\$' >/dev/null
407 sshdgid="-g $SSHDGID"
409 echo "Creating PrivSep group \$SSH_PRIVSEP_GROUP."
410 \$chroot ${PATH_GROUPADD_PROG} \$sshdgid \$SSH_PRIVSEP_GROUP
413 # Create user if required
414 [ "\$DO_PASSWD" = yes ] && {
415 # Use uid of 67 if possible
416 if cut -f3 -d: \${PKG_INSTALL_ROOT}/etc/passwd | egrep '^'$SSHDUID'\$' >/dev/null
420 sshduid="-u $SSHDUID"
422 echo "Creating PrivSep user $SSH_PRIVSEP_USER."
423 \$chroot ${PATH_USERADD_PROG} -c 'SSHD PrivSep User' -s /bin/false -g $SSH_PRIVSEP_USER \$sshduid $SSH_PRIVSEP_USER
424 \$chroot ${PATH_PASSWD_PROG} -l $SSH_PRIVSEP_USER
427 if [ "\${POST_INS_START}" = "yes" ]
431 # See svccfg import note above. The service may already
433 svcadm enable $OPENSSH_FMRI
435 ${TEST_DIR}/etc/init.d/${SYSVINIT_NAME} start
441 ## Build preremove file
442 echo "Building preremove file..."
443 cat > preremove
<< _EOF
448 svcadm disable $OPENSSH_FMRI
450 ${TEST_DIR}/etc/init.d/${SYSVINIT_NAME} stop
454 # local preremove changes here
455 [ -s "${PKG_PREREMOVE_LOCAL}" ] && .
${PKG_PREREMOVE_LOCAL}
457 cat >> preremove
<< _EOF
461 ## Build postremove file
462 echo "Building postremove file..."
463 cat > postremove
<< _EOF
468 if svcs $OPENSSH_FMRI > /dev/null 2>&1
470 svccfg delete -f $OPENSSH_FMRI
475 # local postremove changes here
476 [ -s "${PKG_POSTREMOVE_LOCAL}" ] && .
${PKG_POSTREMOVE_LOCAL}
478 cat >> postremove
<< _EOF
482 ## Build request file
483 echo "Building request file..."
484 cat > request
<< _EOF
489 [ -x /usr
/bin
/ckyorn
] ||
cat >> request
<< _EOF
492 # for some strange reason OpenServer5 has no ckyorn
493 # We build a striped down version here
496 PROMPT="Yes or No [yes,no,?,quit]"
497 HELP_PROMPT=" Enter y or yes if your answer is yes; n or no if your answer is no."
498 USAGE="usage: ckyorn [options]
499 where options may include:
507 while getopts d:p:h: c
510 h) HELP_PROMPT="\$OPTARG" ;;
511 d) DEFAULT=\$OPTARG ;;
512 p) PROMPT=\$OPTARG ;;
513 \\?) echo "\$USAGE" 1>&2
517 shift \`expr \$OPTIND - 1\`
522 echo "\${PROMPT}\\c " 1>&2
524 [ -z "\$key" ] && key=\$DEFAULT
526 [n,N]|[n,N][o,O]|[y,Y]|[y,Y][e,E][s,S]) echo "\${key}\\c"
528 \\?) echo \$HELP_PROMPT 1>&2 ;;
529 q|quit) echo "q\\c" 1>&2
540 # This could get hairy, as the running sshd may not be under SMF.
541 # We'll assume an earlier version of OpenSSH started via SMF.
542 cat >> request
<< _EOF
545 # determine if should restart the daemon
546 if [ -s ${piddir}/sshd.pid ] && \
547 /usr/bin/svcs $OPENSSH_FMRI 2>&1 | egrep "^online" > /dev/null 2>&1
550 -p "Should the running sshd daemon be restarted? ${DEF_MSG}"\` || exit \$?
552 [y,Y]*) PRE_INS_STOP=yes
559 # determine if we should start sshd
561 -p "Start the sshd daemon after installing this package? ${DEF_MSG}"\` || exit \$?
563 [y,Y]*) POST_INS_START=yes ;;
567 # make parameters available to installation service,
568 # and so to any other packaging scripts
570 PRE_INS_STOP='\$PRE_INS_STOP'
571 POST_INS_START='\$POST_INS_START'
576 cat >> request
<< _EOF
580 # Use symbolic links?
582 -p "Do you want symbolic links for the start/stop scripts? ${DEF_MSG}"\` || exit \$?
584 [y,Y]*) USE_SYM_LINKS=yes ;;
587 # determine if should restart the daemon
588 if [ -s ${piddir}/sshd.pid -a -f ${TEST_DIR}/etc/init.d/${SYSVINIT_NAME} ]
591 -p "Should the running sshd daemon be restarted? ${DEF_MSG}"\` || exit \$?
593 [y,Y]*) PRE_INS_STOP=yes
600 # determine if we should start sshd
602 -p "Start the sshd daemon after installing this package? ${DEF_MSG}"\` || exit \$?
604 [y,Y]*) POST_INS_START=yes ;;
608 # make parameters available to installation service,
609 # and so to any other packaging scripts
611 USE_SYM_LINKS='\$USE_SYM_LINKS'
612 PRE_INS_STOP='\$PRE_INS_STOP'
613 POST_INS_START='\$POST_INS_START'
619 # local request changes here
620 [ -s "${PKG_REQUEST_LOCAL}" ] && .
${PKG_REQUEST_LOCAL}
622 cat >> request
<< _EOF
627 ## Next Build our prototype
628 echo "Building prototype file..."
629 cat >mk-proto.
awk << _EOF
630 BEGIN { print "i pkginfo"; print "i depend"; \\
631 print "i preinstall"; print "i postinstall"; \\
632 print "i preremove"; print "i postremove"; \\
633 print "i request"; print "i space"; \\
634 split("$SYSTEM_DIR",sys_files); }
636 for (dir in sys_files) { if ( \$3 != sys_files[dir] )
640 { \$5="root"; \$6="sys"; }
643 { \$4="?"; \$5="?"; \$6="?"; break;}
648 find . |
egrep -v "prototype|pkginfo|mk-proto.awk" |
sort | \
649 pkgproto
$PROTO_ARGS |
${AWK} -f mk-proto.
awk > prototype
651 # /usr/local is a symlink on some systems
652 [ "${USR_LOCAL_IS_SYMLINK}" = yes ] && {
653 grep -v "^d none /usr/local ? ? ?$" prototype
> prototype.new
654 mv prototype.new prototype
657 ## Step back a directory and now build the package.
659 # local prototype tweeks here
660 [ -s "${POST_PROTOTYPE_EDITS}" ] && .
${POST_PROTOTYPE_EDITS}
662 echo "Building package.."
663 pkgmk
-d ${FAKE_ROOT} -f $FAKE_ROOT/prototype
-o
664 echo | pkgtrans
-os ${FAKE_ROOT} ${START}/$PKGNAME-$VERSION$REV-$UNAME_S-$ARCH.pkg
668 rm -fr ${FAKE_ROOT}/${PKGNAME}
669 grep -v "^PSTAMP=" $FAKE_ROOT/pkginfo
> $
$tmp
670 mv $
$tmp $FAKE_ROOT/pkginfo
671 cat >> $FAKE_ROOT/pkginfo
<< _EOF
672 PSTAMP="${UNAME_S} ${OS_VER} ${ARCH} `date '+%d%b%Y %H:%M'`"
674 pkgmk
-d ${FAKE_ROOT} -f $FAKE_ROOT/prototype
-o
675 echo | pkgtrans
-os ${FAKE_ROOT} ${START}/$PKGNAME-$VERSION$REV-$UNAME_S-$ARCH.pkg
680 [ "${REMOVE_FAKE_ROOT_WHEN_DONE}" = yes ] && rm -rf $FAKE_ROOT